//////////////////////////////////////////////////////////////////////
//Beispiel zellulärer Automat: Räuber-Beute Kapitel Game of Life
//////////////////////////////////////////////////////////////////////////
int[][] zellen;
int[][] naechsteZellen;
int breite;
int hoehe;
int q; //Seitenlänge gezeichnetes Quadrats (Zelle)
int feldBreite, feldHoehe;

void setup()
{
  breite = 900;
  hoehe = 600;
  q = 3;
  int leer =0;
  int fuchs = 0;
  int hase = 0;
  feldBreite = breite/q;
  feldHoehe = hoehe/q;
  surface.setSize(breite,hoehe);
  //frameRate(5);//Um besser beobachten zu können
  zellen = new int[breite][hoehe];
  naechsteZellen = new int[breite+2][hoehe+2];
  double artenErzeuger; //bestimmt, was in der Zelle ist: Hase, Fuchs oder leer
  double w0 = 80; //Wahrscheinlichkeit in % für leere Zelle (0)
  double w1 = 15; //Wahrscheinlichkeit in % für Hase (1), der Rest sind Fuchs (2)
  for(int i = 1; i < feldBreite-1; i++)
  {
    for(int j = 1; j < feldHoehe-1; j++)
    {
      artenErzeuger = random(100);
      if(artenErzeuger < w0)
      {
        zellen[i][j] = 0; leer++;
      }
      else if(artenErzeuger < w0+w1)
      {
        zellen[i][j] = 1;   hase++;       //Hase
      }
      else
      {
        zellen[i][j] = 2;  fuchs++;      //Fuchs
      }
    }
  }
 // println( leer,hase,fuchs);//Kontrolle
}

void draw(){
  background(255);
  bewegen();
  zellenAktualisieren();
  zellenZeichnen();
}

void zellenZeichnen() {  
  noStroke();
  for(int i = 1; i < feldBreite-1; i++) {  
    for(int j = 1; j < feldHoehe-1; j++) {  
      if(zellen[i][j] == 0) fill(255); //leer  
      if(zellen[i][j] == 1) fill(0,0,255); //Hase
      if(zellen[i][j] == 2) fill(255,0,0); //Fuchs   
      rect((i-1)*q,(j-1)*q,q,q);
    }
  }
}

void zellenAktualisieren() {
  // Anzahl leer,Hase,Fuchs initialisieren
//  artenZaehler = new int[3];
  
  int HaseNah;
  int fuchsNah;
  for(int i = 1; i < feldBreite-1; i++) {
    for(int j = 1; j < feldHoehe-1; j++) {
    
      HaseNah = 0;
      fuchsNah = 0;
        
      // Nachbarn von Füchsen und Hase zählen in Moore-Nachbarschaft (8 Nachbarn)
      for(int linksRechts = -1; linksRechts <= 1; linksRechts++) {     
        for(int untenOben = -1; untenOben <= 1; untenOben++) {
        
          if(!(linksRechts == 0 && untenOben == 0)){    
            if(zellen[i+untenOben][j+linksRechts] == 1){
               HaseNah++;
            }else if(zellen[i+untenOben][j+linksRechts] == 2) {
               fuchsNah++;
            }
          }
        }
      }
      
      //Regelsatz anwenden
      if(zellen[i][j] == 0) { // leere Zellen
        
        if((fuchsNah ==2 || fuchsNah == 3) && HaseNah >= 3 ) {        
          naechsteZellen[i][j] = 2; //wird zum Fuchs          
        }  
        else if(HaseNah >=3) {          
          naechsteZellen[i][j] = 1; //wird zur Hase          
        }
        else { naechsteZellen[i][j] = 0; //bleibt leer                       
        }
      }    
      else if(zellen[i][j] == 1) { // Hase-Zellen
           
        if(fuchsNah >= 1 && HaseNah >= 2) {       
          naechsteZellen[i][j] = 2;// wird gefressen         
        }
        
        else if(HaseNah <= 1 || HaseNah >= 4 || fuchsNah >= 5)  {  
          // Hase stirbt wegen zu wenig oder zuvielen Hasen oder zuviele Füchse
          naechsteZellen[i][j] = 0;
        }
        else { naechsteZellen[i][j] = 1;//Hase bleibt
        }
      }
     else if(zellen[i][j] == 2) { //Fuchs-Zellen
        //Zuviele Fuchs und wenig Hase: keiner gewinnt 
        if ( fuchsNah >= HaseNah  ) {     
               naechsteZellen[i][j] = 0; 
        } else { naechsteZellen[i][j] = 2;}       
      }      
    }
  }
  
  // Neues Feld in altes Feld
  for(int i = 1; i < feldBreite-1; i++)
  {
    for(int j = 1; j < feldHoehe-1; j++)
    {
      zellen[i][j] = naechsteZellen[i][j];
    }
  }  
}

void bewegen(){ //nicht an den Rändern
  for(int i = 2; i < feldBreite-2; i++) {
    for(int j = 2; j < feldHoehe-2; j++) {
      if(zellen[i][j] ==1){//Hasen zuerst
         int xR =(int) random(-2,2);//Zufällige Bewegung 
         int yR =(int) random(-2,2);
         //Zelle ist leer
         if(zellen[i+xR][j+yR] == 0){
            zellen[i+xR][j+yR] = 1;
            zellen[i][j] = 0;
         }else if(zellen[i+xR][j+yR] == 2){//Uups - das war die falsch Richtung!
           zellen[i][j] = 0;//und das Häschen wird gefressen
         }      
      }
     if(zellen[i][j] ==2){//jetzt die Füchse
        int xR =(int) random(-2,2);//Zufällige Bewegung 
        int yR =(int) random(-2,2);
        //Zelle ist leer oder ein Hase ist darin
        if(zellen[i+xR][j+yR] == 0 || zellen[i+xR][j+yR] == 1 ){
           zellen[i+xR][j+yR] = 2;
           zellen[i][j] = 0;
        }
     }
    }
  }
  
}